// PatroDyne: Patron Supported Dynamic Executables
// Released under LGPL license. See terms at http://www.gnu.org.
package org.patrodyne.etl.transformio;

/**
 * Preference keys.
 * 
 * @author Rick O'Sullivan
 */
public enum PreferenceKey
{
	
	/** The Console history size. */
	ConsoleHistorySize,
	
	/** The Initial source edit mode. */
	InitialSourceEditMode,
	
	/** The Initial wrap source data. */
	InitialWrapSourceData,
	
	/** The Initial wrap target data. */
	InitialWrapTargetData,
	
	/** The Initial wrap console data. */
	InitialWrapConsoleData,
	
	/** The Bound x. */
	BoundX,
	
	/** The Bound y. */
	BoundY,
	
	/** The Bound width. */
	BoundWidth,
	
	/** The Bound height. */
	BoundHeight,
	
	/** The Extended state. */
	ExtendedState,
	
	/** The Font family. */
	FontFamily,
	
	/** The Font size. */
	FontSize,
	
	/** The Font style. */
	FontStyle,
	
	/** The Look and feel. */
	LookAndFeel
}
// vi:set tabstop=4 hardtabs=4 shiftwidth=4:
