//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.5-b10 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.06.21 at 09:44:19 PM EDT 
//


package org.patrodyne.etl.transformio.xml;

import java.util.ArrayList;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import org.jvnet.jaxb2_commons.lang.Equals;
import org.jvnet.jaxb2_commons.lang.EqualsStrategy;
import org.jvnet.jaxb2_commons.lang.HashCode;
import org.jvnet.jaxb2_commons.lang.HashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBEqualsStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBHashCodeStrategy;
import org.jvnet.jaxb2_commons.lang.JAXBToStringStrategy;
import org.jvnet.jaxb2_commons.lang.ToString;
import org.jvnet.jaxb2_commons.lang.ToStringStrategy;
import org.jvnet.jaxb2_commons.locator.ObjectLocator;
import org.jvnet.jaxb2_commons.locator.util.LocatorUtils;


/**
 * 
 * <p>A record is data divided into fields, in fixed number and sequence and identified by name.
 * Each field is given a name, a <em>get</em> regular expression and a <em>set</em> replacement 
 * string. A <a href="http://en.wikipedia.org/wiki/Regular_expression">regular expression</a>
 * or regex provides a concise and flexible means to <em>match</em> (parse) sub-strings of text. 
 * With the two expressions, fields can be parsed and formatted at the same time. For example, 
 * given a record set of telephone numbers, the fields can be parsed and the phone number can be
 * formatted to remove the dashes.</p>
 * 
 * <p><b><code>Data</code></b></p>
 * 
 * <pre>
 * Mary Smith|123-456-7890
 * John Brown|098-765-4321
 * </pre>
 * 
 * <p><b><code>Source</code></b></p>
 * 
 * <pre>
 * &lt;record&gt;
 *     &lt;field name="Name" get="(.*)\|" set="$1"/&gt;
 *     &lt;field name="Phone" get="(...)-(...)-(....)\n" set="$1$2$3"/&gt;
 * &lt;/record&gt;
 * </pre>
 * 
 * <p>The <code>Name</code> field gets and groups all characters before the first pipe
 * <code>'|'</code>. Then, it sets the <code>Name</code> to be the first group without the pipe.</p>
 * 
 * <p>The <code>Phone</code> field gets the three groups of data, found in between the dashes,
 * and prior to the end-of-line character. Then, it sets the <code>Phone</code> field to be all
 * the groups as one compressed value, and omits the EOL.</p>
 * 
 * <p>This is a typical example of extracting data from a source stream. Once the fields are
 * assigned they become available for transformation or inclusion in the target for loading.
 * The target record can change the field order or fields can be omitted. For example:</p>
 * 
 * <p><b><code>Target</code></b></p>
 * 
 * <pre>
 * &lt;record&gt;
 *     &lt;field name="Phone" get="(.*)" set="$1|"/&gt;
 *     &lt;field name="Name" get="(.*)" set="$1\n"/&gt;
 * &lt;/record&gt;
 * </pre>
 * 
 * <p>In this target, the field order has flipped. Both fields get all the data from
 * their assigned values. The <code>Phone</code> field appends a pipe to delimit it
 * from the next field and the <code>Name</code> field appends a new-line character to
 * end the record.</p>
 * 
 * 
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "recordType", propOrder = {
    "fields"
})
public class Record
    implements Equals, HashCode, ToString
{

    @XmlElement(name = "field", required = true)
    protected List<Record.Field> fields;
    @XmlAttribute(name = "exclude")
    protected String exclude;

    /**
     * Gets the value of the fields property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the fields property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getFields().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link Record.Field }
     * 
     * 
     */
    public List<Record.Field> getFields() {
        if (fields == null) {
            fields = new ArrayList<Record.Field>();
        }
        return this.fields;
    }

    /**
     * Gets the value of the exclude property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getExclude() {
        return exclude;
    }

    /**
     * Sets the value of the exclude property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setExclude(String value) {
        this.exclude = value;
    }

    public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
        if (!(object instanceof Record)) {
            return false;
        }
        if (this == object) {
            return true;
        }
        final Record that = ((Record) object);
        {
            List<Record.Field> lhsFields;
            lhsFields = (((this.fields!= null)&&(!this.fields.isEmpty()))?this.getFields():null);
            List<Record.Field> rhsFields;
            rhsFields = (((that.fields!= null)&&(!that.fields.isEmpty()))?that.getFields():null);
            if (!strategy.equals(LocatorUtils.property(thisLocator, "fields", lhsFields), LocatorUtils.property(thatLocator, "fields", rhsFields), lhsFields, rhsFields)) {
                return false;
            }
        }
        {
            String lhsExclude;
            lhsExclude = this.getExclude();
            String rhsExclude;
            rhsExclude = that.getExclude();
            if (!strategy.equals(LocatorUtils.property(thisLocator, "exclude", lhsExclude), LocatorUtils.property(thatLocator, "exclude", rhsExclude), lhsExclude, rhsExclude)) {
                return false;
            }
        }
        return true;
    }

    public boolean equals(Object object) {
        final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
        return equals(null, null, object, strategy);
    }

    public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
        int currentHashCode = 1;
        {
            List<Record.Field> theFields;
            theFields = (((this.fields!= null)&&(!this.fields.isEmpty()))?this.getFields():null);
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "fields", theFields), currentHashCode, theFields);
        }
        {
            String theExclude;
            theExclude = this.getExclude();
            currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "exclude", theExclude), currentHashCode, theExclude);
        }
        return currentHashCode;
    }

    public int hashCode() {
        final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
        return this.hashCode(null, strategy);
    }

    public String toString() {
        final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
        final StringBuilder buffer = new StringBuilder();
        append(null, buffer, strategy);
        return buffer.toString();
    }

    public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        strategy.appendStart(locator, this, buffer);
        appendFields(locator, buffer, strategy);
        strategy.appendEnd(locator, this, buffer);
        return buffer;
    }

    public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
        {
            List<Record.Field> theFields;
            theFields = (((this.fields!= null)&&(!this.fields.isEmpty()))?this.getFields():null);
            strategy.appendField(locator, this, "fields", buffer, theFields);
        }
        {
            String theExclude;
            theExclude = this.getExclude();
            strategy.appendField(locator, this, "exclude", buffer, theExclude);
        }
        return buffer;
    }


    /**
     * 
     * <p>A field represents a single value within a record. It has a name, a get 
     * expression and a set expression. The get expression is a 
     * <a href="http://en.wikipedia.org/wiki/Regular_expression">regular expression</a> 
     * or regex. The set expression is a replacement string. The replacement string
     * may contain references to captured groups (subsequences) from the get pattern.</p>
     * 
     * <p>Note: Field data is treated as text. There is no type conversion
     * because conversion is prone to errors. For example, converting a field to 
     * an integer when the field contains the letter <tt>O</tt>  instead of 
     * the intended number <tt>0</tt> is an error that needs to be trapped
     * and handled. We prefer to keep field parsing and type conversion as two
     * separate concerns. When type conversion is needed, it can be handled in
     * the transformation script where error handling can be better implemented.</p>
     * 
     * 
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "")
    public static class Field
        implements Equals, HashCode, ToString
    {

        @XmlAttribute(name = "name", required = true)
        protected String name;
        @XmlAttribute(name = "get", required = true)
        protected String get;
        @XmlAttribute(name = "set", required = true)
        protected String set;

        /**
         * Gets the value of the name property.
         * 
         * @return
         *     possible object is
         *     {@link String }
         *     
         */
        public String getName() {
            return name;
        }

        /**
         * Sets the value of the name property.
         * 
         * @param value
         *     allowed object is
         *     {@link String }
         *     
         */
        public void setName(String value) {
            this.name = value;
        }

        /**
         * Gets the value of the get property.
         * 
         * @return
         *     possible object is
         *     {@link String }
         *     
         */
        public String getGet() {
            return get;
        }

        /**
         * Sets the value of the get property.
         * 
         * @param value
         *     allowed object is
         *     {@link String }
         *     
         */
        public void setGet(String value) {
            this.get = value;
        }

        /**
         * Gets the value of the set property.
         * 
         * @return
         *     possible object is
         *     {@link String }
         *     
         */
        public String getSet() {
            return set;
        }

        /**
         * Sets the value of the set property.
         * 
         * @param value
         *     allowed object is
         *     {@link String }
         *     
         */
        public void setSet(String value) {
            this.set = value;
        }

        public boolean equals(ObjectLocator thisLocator, ObjectLocator thatLocator, Object object, EqualsStrategy strategy) {
            if (!(object instanceof Record.Field)) {
                return false;
            }
            if (this == object) {
                return true;
            }
            final Record.Field that = ((Record.Field) object);
            {
                String lhsName;
                lhsName = this.getName();
                String rhsName;
                rhsName = that.getName();
                if (!strategy.equals(LocatorUtils.property(thisLocator, "name", lhsName), LocatorUtils.property(thatLocator, "name", rhsName), lhsName, rhsName)) {
                    return false;
                }
            }
            {
                String lhsGet;
                lhsGet = this.getGet();
                String rhsGet;
                rhsGet = that.getGet();
                if (!strategy.equals(LocatorUtils.property(thisLocator, "get", lhsGet), LocatorUtils.property(thatLocator, "get", rhsGet), lhsGet, rhsGet)) {
                    return false;
                }
            }
            {
                String lhsSet;
                lhsSet = this.getSet();
                String rhsSet;
                rhsSet = that.getSet();
                if (!strategy.equals(LocatorUtils.property(thisLocator, "set", lhsSet), LocatorUtils.property(thatLocator, "set", rhsSet), lhsSet, rhsSet)) {
                    return false;
                }
            }
            return true;
        }

        public boolean equals(Object object) {
            final EqualsStrategy strategy = JAXBEqualsStrategy.INSTANCE;
            return equals(null, null, object, strategy);
        }

        public int hashCode(ObjectLocator locator, HashCodeStrategy strategy) {
            int currentHashCode = 1;
            {
                String theName;
                theName = this.getName();
                currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "name", theName), currentHashCode, theName);
            }
            {
                String theGet;
                theGet = this.getGet();
                currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "get", theGet), currentHashCode, theGet);
            }
            {
                String theSet;
                theSet = this.getSet();
                currentHashCode = strategy.hashCode(LocatorUtils.property(locator, "set", theSet), currentHashCode, theSet);
            }
            return currentHashCode;
        }

        public int hashCode() {
            final HashCodeStrategy strategy = JAXBHashCodeStrategy.INSTANCE;
            return this.hashCode(null, strategy);
        }

        public String toString() {
            final ToStringStrategy strategy = JAXBToStringStrategy.INSTANCE;
            final StringBuilder buffer = new StringBuilder();
            append(null, buffer, strategy);
            return buffer.toString();
        }

        public StringBuilder append(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
            strategy.appendStart(locator, this, buffer);
            appendFields(locator, buffer, strategy);
            strategy.appendEnd(locator, this, buffer);
            return buffer;
        }

        public StringBuilder appendFields(ObjectLocator locator, StringBuilder buffer, ToStringStrategy strategy) {
            {
                String theName;
                theName = this.getName();
                strategy.appendField(locator, this, "name", buffer, theName);
            }
            {
                String theGet;
                theGet = this.getGet();
                strategy.appendField(locator, this, "get", buffer, theGet);
            }
            {
                String theSet;
                theSet = this.getSet();
                strategy.appendField(locator, this, "set", buffer, theSet);
            }
            return buffer;
        }

    }

}
